﻿<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xml:lang="en">
<head>
  <title>CSS Quoting Full Disclosure - Security - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="description" content="Full disclosure security page detailing the CSS quoting attack." />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, standards, compliant, 4.1.1, attack, full disclosure, xss, security, quoting, css, internet explorer" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">CSS Quoting Full Disclosure</h1>

<div id="content">

<p>
  Non-standard parsing behavior of strings in CSS expressions in
  Internet Explorer could allow a clever attacker to escape the string
  and execute arbitrary JavaScript via CSS.  The three CSS properties
  that HTML Purifier enabled that take strings as inputs are
  <code>background-image</code>, <code>background</code> and
  <code>font-family</code>; instances of HTML Purifier that did not
  enable these properties were not vulnerable.
</p>

<p>
  This vulnerability was reported privately to the vendor by
  <a href="http://mario.heideri.ch/">Mario Heiderich</a>.
  <a href="http://d.hatena.ne.jp/teracc/">Takeshi Terada</a>
  was consulted during the construction of the fix.  David Ross of
  the Internet Explorer team was separately informed of this class of
  exploits.  Shortly prior to the release of 4.1.1, a post
  to <a
      href="http://sla.ckers.org/forum/read.php?2,34579">sla.ckers.org</a>
  was made to sanity check the new proposed fix.  No active exploits are
  currently known.
</p>

<h2 id="Fix">Fix</h2>

<p>
  There are several quirks in Internet Explorer's parsing of string-like
  expressions in CSS that caused this security vulnerability.  They are as
  follows:
</p>

<ol>
  <li>Internet Explorer treats the second instance of an unprotected
  exclamation mark as a valid ending delimiter for its CSS parser (no
  semicolon is necessary in this case), and</li>
  <li>Internet Explorer does not recognize CSS escape characters
  <code>\"</code> and <code>\'</code> in strings.</li>
</ol>

<p>
  Thus, the original implementation of <code>url()</code> in
  <code>background-image</code> and friends was vulnerable
  because it did not use quoting and relied on character escaping, and
  the original implementation of <code>font-family</code> was vulnerable
  because it expected to be able to escape internal apostrophes in its
  string.  The initial fix merely added quoting to <code>url()</code>
  but failed to address Internet Explorer's broken character escaping.
</p>

<p>
  At this point, there appeared to be a problem: it seemed impossible to
  express the full range of permitted URLs and font names: the
  characters that Internet Explorer did not seem to be able to escape
  were also valid characters in URLs and font names.
</p>

<p>
  URLs were resolved in the following manner: while a single quote was a
  valid character for a URL, a double quote was not.  A backslash was
  never a valid character.  Thus, if the <code>url("...")</code> form
  was used, no escaping would be necessary.
</p>

<p>
  Font names were resolved in a similar fashion (apostrophes are far
  more common in font names than double quotes), but with an extra
  observation made by Takeshi Terada: while Internet Explorer did not
  support <code>\"</code> style character escapes, it did support
  hexadecimal character escapes.  Thus, quotes and backslashes could be
  portably preserved in font names.
</p>

<h2 id="History">History</h2>

<p>
  The vulnerability was reported on April 25, 2010 via email.  The first
  incorrect patch was committed to the public repository on <a
      href="http://repo.or.cz/w/htmlpurifier.git/commit/da94d3d6acdf417ac890426eb1fd239ba62b042d">April 26, 2010</a>
  with the summary: <q>Always quote the contents of url() in CSS.</q>
  HTML Purifier 4.1.0 was released on April 26, 2010.
</p>

<p>
  On April 27, 2010, Mario Heiderich realized that the fix was
  insufficient.  A long private discussion ensued on possible fixes, but
  we were unable to determine a solution that would not invalidate
  previously valid CSS expressions.
</p>

<p>
  On May 20, 2010, I contacted Takeshi Terada and we came up with a
  feasible solution.  A patch was committed on <a
      href="http://repo.or.cz/w/htmlpurifier.git/commit/d3abcb90e30592c619047d878cf9c72b7c5836a3">June 1, 2010</a>
  with the summary <q>Rewrite CSS url() and font-family output
      logic.</q> HTML Purifier 4.1.1 was released on June 1, 2010.
</p>

<p>
  The HTML Purifier team realizes that the month long interval between
  the discovery of the second security vulnerability and the fix was not
  ideal, and hopes to maintain a fast turnaround for security
  vulnerabilities in the future.
</p>

</div>
</div>

</body>
</html>
